=== modified file 'drizzled/common_fwd.h'
--- drizzled/common_fwd.h	2011-03-28 17:55:27 +0000
+++ drizzled/common_fwd.h	2011-03-28 21:29:18 +0000
@@ -119,6 +119,11 @@
   class Transactions;
 }
 
+namespace sql
+{
+  class ResultSet;
+}
+
 namespace table 
 { 
   class Placeholder; 

=== modified file 'drizzled/cursor.h'
--- drizzled/cursor.h	2011-03-28 21:07:04 +0000
+++ drizzled/cursor.h	2011-03-28 21:29:18 +0000
@@ -45,20 +45,11 @@
 typedef List<Item> List_item;
 extern KEY_CREATE_INFO default_key_create_info;
 
-/* Forward declaration for condition pushdown to storage engine */
-typedef class Item COND;
-
-typedef struct system_status_var system_status_var;
-
-namespace optimizer { class CostVector; }
-namespace plugin { class StorageEngine; }
-
 /*
   bitmap with first N+1 bits set
   (keypart_map for a key prefix of [0..N] keyparts)
 */
-template<class T>
-inline key_part_map make_keypart_map(T a)
+inline key_part_map make_keypart_map(int a)
 {
   return (((key_part_map)2 << a) - 1);
 }
@@ -67,8 +58,7 @@
   bitmap with first N bits set
   (keypart_map for a key prefix of [0..N-1] keyparts)
 */
-template<class T>
-inline key_part_map make_prev_keypart_map(T a)
+inline key_part_map make_prev_keypart_map(int a)
 {
   return (((key_part_map)1 << a) - 1);
 }
@@ -621,7 +611,6 @@
 /* basic stuff */
 void ha_init_errors(void);
 
-class SortField;
 SortField *make_unireg_sortorder(Order *order, uint32_t *length,
                                  SortField *sortorder);
 int setup_order(Session *session, Item **ref_pointer_array, TableList *tables,

=== modified file 'drizzled/diagnostics_area.h'
--- drizzled/diagnostics_area.h	2011-03-22 09:36:03 +0000
+++ drizzled/diagnostics_area.h	2011-03-28 21:29:18 +0000
@@ -26,8 +26,6 @@
 
 namespace drizzled {
 
-class Session;
-
 /**
   Stores status of the currently executed statement.
   Cleared at the beginning of the statement, and then

=== modified file 'drizzled/drizzled.h'
--- drizzled/drizzled.h	2011-03-14 05:40:28 +0000
+++ drizzled/drizzled.h	2011-03-28 21:29:18 +0000
@@ -22,21 +22,14 @@
 
 #include <bitset>
 #include <boost/program_options.hpp>
-
 #include <boost/detail/atomic_count.hpp>
-
+#include <drizzled/common_fwd.h>
 #include <drizzled/global_buffer.h>
 #include <drizzled/definitions.h>
 
 struct passwd;
 
-namespace drizzled
-{
-
-namespace module
-{
-class Registry;
-}
+namespace drizzled {
 
 extern boost::detail::atomic_count connection_count;
 extern const char *load_default_groups[];

=== modified file 'drizzled/dtcollation.h'
--- drizzled/dtcollation.h	2011-03-14 05:40:28 +0000
+++ drizzled/dtcollation.h	2011-03-28 21:29:18 +0000
@@ -22,11 +22,7 @@
 #include <drizzled/definitions.h>
 #include <drizzled/visibility.h>
 
-namespace drizzled
-{
-
-class Item;
-struct charset_info_st;
+namespace drizzled {
 
 class DRIZZLED_API DTCollation
 {

=== modified file 'drizzled/enum_nested_loop_state.h'
--- drizzled/enum_nested_loop_state.h	2011-03-14 05:40:28 +0000
+++ drizzled/enum_nested_loop_state.h	2011-03-28 21:29:18 +0000
@@ -19,8 +19,9 @@
 
 #pragma once
 
-namespace drizzled
-{
+#include <drizzled/common_fwd.h>
+
+namespace drizzled {
 
 /** The states in which a nested loop join can be in */
 enum enum_nested_loop_state
@@ -33,9 +34,6 @@
   NESTED_LOOP_CURSOR_LIMIT= 4
 };
 
-class Join;
-class JoinTable;
-
 typedef enum_nested_loop_state (*Next_select_func)(Join *, JoinTable *, bool);
 typedef int (*Read_record_func)(JoinTable *tab);
 Next_select_func setup_end_select_func(Join *join);

=== modified file 'drizzled/execute.h'
--- drizzled/execute.h	2011-03-14 05:40:28 +0000
+++ drizzled/execute.h	2011-03-28 21:29:18 +0000
@@ -22,13 +22,7 @@
 
 #include <drizzled/visibility.h>
 
-namespace drizzled
-{
-
-namespace sql
-{
-  class ResultSet;
-}
+namespace drizzled {
 
 class DRIZZLED_API Execute
 {

=== modified file 'drizzled/field.h'
--- drizzled/field.h	2011-03-28 02:46:21 +0000
+++ drizzled/field.h	2011-03-28 21:29:18 +0000
@@ -41,13 +41,12 @@
 
 #include <drizzled/visibility.h>
 
-namespace drizzled
-{
+namespace drizzled {
 
 #define DATETIME_DEC                     6
 #define DOUBLE_TO_STRING_CONVERSION_BUFFER_SIZE FLOATING_POINT_BUFFER
 
-#ifdef DEBUG
+#ifdef DEBUG // todo: remove non-debug
 #define ASSERT_COLUMN_MARKED_FOR_READ assert(!getTable() || (getTable()->read_set == NULL || isReadSet()))
 #define ASSERT_COLUMN_MARKED_FOR_WRITE assert(!getTable() || (getTable()->write_set == NULL || isWriteSet()))
 #else
@@ -57,12 +56,6 @@
 
 const uint32_t max_field_size= (uint32_t) 4294967295U;
 
-class SendField;
-class CreateField;
-class TableShare;
-class Field;
-struct CacheField;
-
 int field_conv(Field *to,Field *from);
 
 /**

=== modified file 'drizzled/field_iterator.h'
--- drizzled/field_iterator.h	2011-03-14 05:40:28 +0000
+++ drizzled/field_iterator.h	2011-03-28 21:29:18 +0000
@@ -27,9 +27,6 @@
 
 namespace drizzled {
 
-class Table;
-class TableList;
-
 /*
   Iterator over the fields of a generic table reference.
 */

=== modified file 'drizzled/filesort.h'
--- drizzled/filesort.h	2011-03-14 05:40:28 +0000
+++ drizzled/filesort.h	2011-03-28 21:29:18 +0000
@@ -33,17 +33,8 @@
 
 namespace drizzled {
 
-class Session;
-class Table;
-class SortField;
-
-namespace optimizer {
-class SqlSelect;
-}
-
-class SortParam;
-
-class FileSort {
+class FileSort 
+{
   Session &_session;
 
   uint32_t sortlength(SortField *sortorder, uint32_t s_length, bool *multi_byte_charset);

=== modified file 'drizzled/visibility.h'
--- drizzled/visibility.h	2011-03-14 05:40:28 +0000
+++ drizzled/visibility.h	2011-03-28 21:29:18 +0000
@@ -27,6 +27,8 @@
 
 #pragma once
 
+#include <drizzled/common_fwd.h>
+
 /**
  *
  * DRIZZLED_API is used for the public API symbols. It either DLL imports or

